(function (Drupal) {
  let initialised = false;
  Drupal.behaviors.copy_to_clipboard = {
    attach: function (context) {
      if (!initialised && context === document) {
        initialised = true;

        let copy_function = function() {
          let input = this.previousElementSibling;
          let text_to_copy = input.value;
          navigator.clipboard.writeText(text_to_copy).then(() => {
            input.focus();
          },() => {
            alert(Drupal.t('Could not copy value to clipboard.'));
          });
        };

        let copy_buttons = document.querySelectorAll('.copy-to-clipboard');
        copy_buttons.forEach(element => {
          element.addEventListener('click', copy_function);
        });
      }
    }
  };
})(Drupal);
