<?php

namespace Drupal\drupalorg\Traits;

use Gitlab\Client;

/**
 * Helper function to get a Gitlab client instance.
 */
trait GitLabClientTrait {

  /**
   * Return a gitlab client instance.
   *
   * @return \Gitlab\Client
   *   Client instance.
   */
  protected function getGitLabClient(): Client {
    $config = \Drupal::config('drupalorg.gitlab_settings');
    if (
      empty($config->get('host')) ||
      empty($config->get('token')) ||
      $config->get('token') === 'CHANGE-ME'
    ) {
      throw new \Exception('GitLab host or token not set.');
    }
    $gitlab_client = new Client();
    $gitlab_client->setUrl($config->get('host'));
    $gitlab_client->authenticate($config->get('token'), Client::AUTH_HTTP_TOKEN);

    return $gitlab_client;
  }

}
